//+------------------------------------------------------------------+
//|                                           TimeRange.mq4          |
//+------------------------------------------------------------------+

extern int    minpoints  = 100;
extern string file       = "EURUSD5.csv";
int prevtime;

//+------------------------------------------------------------------+
int deinit() {
 del("tm");
 del("op");
 del("hi");
 del("lo");
 del("vol");
 del("pdir");
 Print("Open your Metatrader/tester/files folder to find file: " + file);
 Print("This file is ready to import through the History Center");
 return(0);
}
//+------------------------------------------------------------------+

int start()
  {
   if(Bars<5) return(0);
   if(prevtime==Time[0]) return(0);
   prevtime=Time[0];
   
   if(!IsTesting()) {
    Print("This program works on backtest only");
    return(0);
   }
   
   int    mincandles   = 1;
   double multipler    = 2.0;
   int    candletime   = Period()*60;
   int    mintime      = candletime*mincandles;
   double minsize      = minpoints*Point;
   int    volume       = get("vol")+Volume[1];
   
   if(get("op")==0) {
    set("tm",Time[0]);
    set("op",Open[0]);
    set("hi",Open[0]);
    set("lo",Open[0]);
   }
   
   if(Time[0]>get("tm")) {
    if(High[1]>get("hi")) {
     set("hi",High[1]);
    }
    if(Low[1]<get("lo")) {
     set("lo",Low[1]);
    }
    if(Open[0]>get("hi")) {
     set("hi",Open[0]);
    }
    if(Open[0]<get("lo")) {
     set("lo",Open[0]);
    }
    set("vol",volume);
   }
   
   string row      = "";
   string op0      = DoubleToStr(Open[0],5);
   string op1      = DoubleToStr(get("op"),5);
   string hi       = DoubleToStr(get("hi"),5);
   string lo       = DoubleToStr(get("lo"),5);
   string prevtime = TimeToStr(get("tm"),TIME_DATE|TIME_MINUTES);
   
   if(Time[0]>=get("tm")+mintime) {
    if(get("pdir")==0) {
     if(Open[0]>=get("op")+minsize) {
      row = prevtime+","+op1+","+hi+","+lo+","+op0+","+volume;
      write(row,file);
      set("tm",Time[0]);
      set("op",Open[0]);
      set("hi",Open[0]);
      set("lo",Open[0]);
      set("pdir",2);
      del("vol");
     }
     if(Open[0]<=get("op")-minsize) {
      row = prevtime+","+op0+","+hi+","+lo+","+op1+","+volume;
      write(row,file);
      set("tm",Time[0]);
      set("op",Open[0]);
      set("hi",Open[0]);
      set("lo",Open[0]);
      set("pdir",1);
      del("vol");
     }
    } else {
     if(get("pdir")==2) {
      if(Open[0]>=get("op")+minsize) {
       row = prevtime+","+op1+","+hi+","+lo+","+op0+","+volume;
       write(row,file);
       set("tm",Time[0]);
       set("op",Open[0]);
       set("hi",Open[0]);
       set("lo",Open[0]);
       set("pdir",2);
       del("vol");
      }
      if(Open[0]<=get("op")-(multipler*minsize)) {
       row = prevtime+","+op1+","+hi+","+lo+","+op0+","+volume;
       write(row,file);
       set("tm",Time[0]);
       set("op",Open[0]);
       set("hi",Open[0]);
       set("lo",Open[0]);
       set("pdir",1);
       del("vol");
      }
     }
     if(get("pdir")==1) {
      if(Open[0]>=get("op")+(multipler*minsize)) {
       row = prevtime+","+op1+","+hi+","+lo+","+op0+","+volume;
       write(row,file);
       set("tm",Time[0]);
       set("op",Open[0]);
       set("hi",Open[0]);
       set("lo",Open[0]);
       set("pdir",2);
       del("vol");
      }
      if(Open[0]<=get("op")-minsize) {
       row = prevtime+","+op1+","+hi+","+lo+","+op0+","+volume;
       write(row,file);
       set("tm",Time[0]);
       set("op",Open[0]);
       set("hi",Open[0]);
       set("lo",Open[0]);
       set("pdir",1);
       del("vol");
      }
     }
    }
   }
 return(0);
}
void set(string name, double value) {
 GlobalVariableSet(name,value);
}
double get(string name) {
 return(GlobalVariableGet(name));
}
void del(string name) {
 GlobalVariableDel(name);
}
void write(string row, string fname) {
 int iFile = FileOpen(fname,FILE_CSV|FILE_READ|FILE_WRITE,",");
 FileSeek(iFile,0,SEEK_END);
 FileWrite(iFile,row);
 FileClose(iFile);
}